<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEcoMonitorReportItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfEcoMonitorReportItem extends AbstractStructArrayBase
{
    /**
     * The EcoMonitorReportItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EcoMonitorReportItem[]
     */
    public $EcoMonitorReportItem;
    /**
     * Constructor method for ArrayOfEcoMonitorReportItem
     * @uses ArrayOfEcoMonitorReportItem::setEcoMonitorReportItem()
     * @param \StructType\EcoMonitorReportItem[] $ecoMonitorReportItem
     */
    public function __construct(array $ecoMonitorReportItem = array())
    {
        $this
            ->setEcoMonitorReportItem($ecoMonitorReportItem);
    }
    /**
     * Get EcoMonitorReportItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EcoMonitorReportItem[]|null
     */
    public function getEcoMonitorReportItem()
    {
        return isset($this->EcoMonitorReportItem) ? $this->EcoMonitorReportItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setEcoMonitorReportItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEcoMonitorReportItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEcoMonitorReportItemForArrayConstraintsFromSetEcoMonitorReportItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfEcoMonitorReportItemEcoMonitorReportItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfEcoMonitorReportItemEcoMonitorReportItemItem instanceof \StructType\EcoMonitorReportItem) {
                $invalidValues[] = is_object($arrayOfEcoMonitorReportItemEcoMonitorReportItemItem) ? get_class($arrayOfEcoMonitorReportItemEcoMonitorReportItemItem) : sprintf('%s(%s)', gettype($arrayOfEcoMonitorReportItemEcoMonitorReportItemItem), var_export($arrayOfEcoMonitorReportItemEcoMonitorReportItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EcoMonitorReportItem property can only contain items of type \StructType\EcoMonitorReportItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EcoMonitorReportItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem[] $ecoMonitorReportItem
     * @return \ArrayType\ArrayOfEcoMonitorReportItem
     */
    public function setEcoMonitorReportItem(array $ecoMonitorReportItem = array())
    {
        // validation for constraint: array
        if ('' !== ($ecoMonitorReportItemArrayErrorMessage = self::validateEcoMonitorReportItemForArrayConstraintsFromSetEcoMonitorReportItem($ecoMonitorReportItem))) {
            throw new \InvalidArgumentException($ecoMonitorReportItemArrayErrorMessage, __LINE__);
        }
        if (is_null($ecoMonitorReportItem) || (is_array($ecoMonitorReportItem) && empty($ecoMonitorReportItem))) {
            unset($this->EcoMonitorReportItem);
        } else {
            $this->EcoMonitorReportItem = $ecoMonitorReportItem;
        }
        return $this;
    }
    /**
     * Add item to EcoMonitorReportItem value
     * @throws \InvalidArgumentException
     * @param \StructType\EcoMonitorReportItem $item
     * @return \ArrayType\ArrayOfEcoMonitorReportItem
     */
    public function addToEcoMonitorReportItem(\StructType\EcoMonitorReportItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EcoMonitorReportItem) {
            throw new \InvalidArgumentException(sprintf('The EcoMonitorReportItem property can only contain items of type \StructType\EcoMonitorReportItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EcoMonitorReportItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EcoMonitorReportItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EcoMonitorReportItem
     */
    public function getAttributeName()
    {
        return 'EcoMonitorReportItem';
    }
}
